<?
GUIFactory::setMainGUI("shell");
$DEBUG_SETTINGS["noinfo"] = true;

$config = array( );


securebyallowedips();

if(!function_exists('str_split')) {
 function str_split($str) {
 return explode("\r\n", chunk_split($str,1));
 }
}

function umerge($arrays){
 $result = array();
 foreach ($arrays as $array){
 $array = (array) $array;
 foreach ($array as $value){
 if (array_search($value,$result)===false)$result[]=$value;
 }
 }
 return $result;
}




function extendAlohaPlugins() {
 
 global $ALOHA_PLUGINS_GLOBAL, $CUSTOM_ALOHA_PLUGINS, $ALOHA_PLUGINS_NODE, $FEATURE, $ALOHA_JQUERYUI_PLUGINS_GLOBAL;

 
 $ALOHA_PLUGINS_GLOBAL = umerge(array($ALOHA_PLUGINS_GLOBAL, $CUSTOM_ALOHA_PLUGINS));

 
 $ALOHA_PLUGINS_GLOBAL = umerge(array($ALOHA_JQUERYUI_PLUGINS_GLOBAL, $ALOHA_PLUGINS_GLOBAL));
 
 
 $ALOHA_PLUGINS_NODE_NEW = $ALOHA_PLUGINS_NODE;
 $ALOHA_PLUGINS_NODE = array();
 foreach($ALOHA_PLUGINS_NODE_NEW as $nodeId => $alohaNodePlugins) {
 $ALOHA_PLUGINS_NODE[$nodeId]= umerge(array($ALOHA_PLUGINS_GLOBAL, $alohaNodePlugins));
 }

}




function extendAlohaSettings() {
 global $FEATURE, $ALOHA_JQUERYUI_SETTINGS, $ALOHA_SETTINGS;
 
 foreach($ALOHA_JQUERYUI_SETTINGS as $key => $value) {
 $ALOHA_SETTINGS[$key] = $value;
 }
}







function _utf8_to_java ($data) {
 $ret = 0;
 foreach((str_split(strrev(chr((ord($data{0}) % 252 % 248 % 240 % 224 % 192) + 128) . substr($data, 1)))) as $k => $v)
 $ret += (ord($v) % 128) * pow(64, $k);
 return "\u" . sprintf("%04x",$ret);
}




function utf8_to_java($data) {
 return preg_replace("/([\\xC0-\\xF7]{1,1}[\\x80-\\xBF]+)/e", '_utf8_to_java("\\1")', $data);
}

function createProperties( &$config, $arr, $prefix ) {

 if (!is_array($arr)) {
 return false;
 }

 foreach( $arr as $key => $value ) {
 $key = str_replace("\\", "\\\\", $key);
 $key = str_replace(" ", "\\ ", $key);
 if(is_array($value)) {
 $keys = array_keys($value);
 if (count($value) == 0) {
 
 $config["$prefix$key"] = "__GTX__ARRAY__";
 } else if ($keys[0] == "0") {
 $config["$prefix$key"] = "__GTX__ARRAY__";
 } else {
 $value_keys = array();
 foreach ( $value as $value_key => $value_value ) {
 $value_keys[] = urlencode($value_key);
 }
 $config["$prefix$key"] = "__GTX__ARRAY__ " . join( ',', $value_keys );
 }
 createProperties( &$config, $value, $prefix.$key.'.' );
 } else {
 
 if ($value === false) $value = "False";
 $value = str_replace("\n","\\n", $value);
 $value = str_replace("\r","", $value);
 $value = utf8_to_java( $value );
 $config["$prefix$key"] = $value;
 }
 }
}
function createDBProperties( &$config, $settings, $prefix ) {
 $config[$prefix.'url'] = mydb_get_jdbc_url( $settings );
 $config[$prefix.'driverClass'] = mydb_get_jdbc_driver( $settings );
 createProperties( $config, $settings, $prefix );
}

extendAlohaPlugins();
extendAlohaSettings();



createDBProperties( &$config, $SETTINGS, 'db.settings.' );
createDBProperties( &$config, $CN_MAP_DB_SETTINGS, 'db.cn_map_db_settings.' );

createProperties( &$config, $JCONFIG, 'config.' );

foreach( $GLOBAL_CONFIG_VARS as $configName ) {
 global $$configName;
 $prefix = 'global.config.'.strtolower($configName);
 if( is_array( $$configName ) ) {
 $keys = array_keys($$configName);
 if ($keys[0] == "0") {
 
 $config[$prefix] = '__GTX__ARRAY__';
 } else {
 
 $config[$prefix] = '__GTX__ARRAY__ '.join( ',', array_keys( $$configName ) );
 }
 createProperties( &$config, $$configName, $prefix.'.' );
 } else {
 $config[$prefix] = $$configName;
 }
}


foreach( $FEATURE as $key => $value ) {
 if (is_array ($value)) {
 
 $keys = array_keys($value);
 $config["feature.$key"] = '__GTX__ARRAY__ '.join(',', $keys);
 createProperties(&$config, $value, "feature.$key.");
 } else {
 
 $config["feature.$key"] = $value ? 'True' : 'False';
 }
}


$config['nodepath'] = $FILEPATH;
$config['tagprefix'] = $TAG_PREFIX;
$config['url'] = $CN_LOCAL_SERVER.$CN_LOCAL_PATH;
$config['linkway'] = $LINKWAY;
$config['linkway_file'] = isset($LINKWAY_FILE) ? $LINKWAY_FILE : $LINKWAY;
$config['linkway_file_path'] = $LINKWAY_FILE_PATH;
$config['internal.globalprefix'] = get_globalprefix();
$config['maxfilesize'] = filesize2bytes($MAX_FILESIZE);

createProperties(&$config, $XNL_FUNCTION, "xnl_function.");
$config["xnl_function"] = '__GTX__ARRAY__';

createProperties(&$config, $PUBLISH_LOAD_BALANCING, "config.loadbalancing.");


$VELOCITY_PROPERTIES["keys"] = implode(",", array_keys($VELOCITY_PROPERTIES));
createProperties(&$config, $VELOCITY_PROPERTIES, "velocity.");

$HTML_HEADER = false;
$HTML_FOOTER = false;
?>
