<?

class SyncUserGroup extends BaseObject {

 var $config;
 var $configVars;

 function SyncUserGroup($config, $vars) {
 $this->config = $config;
 $this->configVars = $vars;
 mysession_var_reg("SYNCUSERGROUP");
 }

 function gotUserData() {
 $_user = $this->config["user"];
 global $$_user;
 return ($$_user)?true:false;
 }

 function loadUserData() {
 global $SYNCUSERGROUP;
 
 
 $_user = $this->config["user"];
 global $$_user;
 $user = $$_user;
 $splitter = $this->config["splitter"];
 if ($user == "") return false;

 if ($splitter) {
 $users = explode($splitter, $user);
 } else {
 $users = array($user);
 }

 $type = strtolower($this->config["type"]);

 
 $config = array();
 $params = array();
 if ($type == "http") {
 if ($this->configVars["splitter"]) $config["splitter"] = $this->configVars["splitter"];
 reset($this->configVars);
 while (list($key,$val) = each($this->configVars)) {
 if ($key == "splitter") continue;
 $_param = $val;
 global $$_param;
 if ($$_param) {
 $config[$key] = $key;
 $params[$key] = $$_param;
 }
 }
 $config["login"] = "login";
 }

 
 $syncs = array();
 while (list($key,$val) = each($users)) {
 if ($type == "ldap") {
 $sync = new LDAPSync();
 if (strtolower($this->config["user_type"]) == "dn") {
 $sync->getUserFromDN($val);
 } else {
 $sync->getUserFromLogin($val);
 }
 } else {
 $params["login"] = $val;
 $sync = new HTTPSync($config);
 $sync->getUserFromParams($params);
 }
 $sync->syncToDB(0,false);
 $syncs[$val] = serialize($sync);
 }

 $SYNCUSERGROUP["syncs"] = $syncs;
 $SYNCUSERGROUP["users"] = $users;

 if ($_backurl = $this->config["backurl"]) {
 global $$_backurl;
 if ($$_backurl) {
 $SYNCUSERGROUP["backurl"] = $$_backurl;
 } else {
 $SYNCUSERGROUP["backurl"] = false;
 }
 } else {
 $SYNCUSERGROUP["backurl"] = false;
 }
 
 }

 function isSingleUser() {
 global $SYNCUSERGROUP;
 return (count($SYNCUSERGROUP["users"]) == 1);
 }

 function getUserIDs() {
 global $SYNCUSERGROUP;
 $syncs = $SYNCUSERGROUP["syncs"];
 $rs = array();
 reset($syncs);
 while (list($key,$sync) = each($syncs)) {
 $sync = unserialize($sync);
 $rs[] = $sync->getUserID();
 }
 return $rs;
 }

 function getUserKeys() {
 global $SYNCUSERGROUP;
 return $SYNCUSERGROUP["users"];
 }

 function useRedirect() {
 global $SYNCUSERGROUP;
 return ($SYNCUSERGROUP["backurl"])?true:false;
 }

 function getBaseRedirectURL($addParam = "") {
 global $SYNCUSERGROUP;
 $url = $SYNCUSERGROUP["backurl"];
 if ($addParam) {
 $url .= (strpos($url,"?"))?"&":"?";
 $c = substr($addParam,0,1);
 if ($c == "&" || $c == "?") {
 $url .= substr($addParam,1);
 } else {
 $url .= $addParam;
 }
 }
 return $url;
 }

 function getRedirectURL($singleUser = false) {
 global $SYNCUSERGROUP;
 $url = $SYNCUSERGROUP["backurl"];
 $url .= (strpos($url,"?"))?"&":"?";
 
 $syncs = $SYNCUSERGROUP["syncs"];

 if ($singleUser) {
 list($key, $sync) = each($syncs);
 $sync = unserialize($sync);
 $sync->getUserFromDB();
 $url .= $this->configVars["group"]."=".urlencode(implode($this->configVars["splitter"],$sync->getGroups()));
 } else {
 $users = "";
 reset($syncs);
 while (list($key,$sync) = each($syncs)) {
 $sync = unserialize($sync);
 $sync->getUserFromDB();
 if ($users) $users .= $this->config["splitter"];
 $users .= rawurlencode($key).$this->config["splitter"];
 $users .= urlencode(implode($this->configVars["splitter"],$sync->getGroups()));
 $syncs[$key] = serialize($sync);
 }
 $SYNCUSERGROUP["syncs"] = $syncs;
 
 $url .= $this->config["user"]."=".$users;
 }
 
 return $url;
 }

 function storeUserData() {
 global $SYNCUSERGROUP;
 $syncs = $SYNCUSERGROUP["syncs"];
 $type = strtolower($this->config["type"]);
 reset($syncs);
 while (list($key,$val) = each($syncs)) {
 $sync = unserialize($val);

 $sync->getUserFromDB();
 if ($type == "ldap") {
 $sync->syncToLDAP();
 }

 $syncs[$key] = serialize($sync);
 }
 return true;
 }

 function getNoChangeVar() {
 return $this->config["nochange"];
 }

}

?>
